unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, NCalendar, ExtCtrls;

type
  TForm1 = class(TForm)
    Calendar: TNCalendar;
    Memo1: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Panel3: TPanel;
    Label16: TLabel;
    Edit14: TEdit;
    procedure CalendarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.CalendarClick(Sender: TObject);
Var
   AText  : String;
   I      : Integer;

function PhaseName(Index: Integer): String;
begin
     Case Index Of
     0    : Result:= 'New Moon';
     1    : Result:= 'First Quarter';
     2    : Result:= 'Full Moon';
     3    : Result:= 'Last Quarter';
     end;
end;

begin
     Edit1.Text:= IntToStr(Calendar.Year);
     Edit2.Text:= IntToStr(Calendar.Month);
     Edit3.Text:= IntToStr(Calendar.Day);
     Edit4.Text:= Format('%7.1f',[Calendar.JulianDay]);
     Edit5.Text:= Calendar.FormatJulianDay(Calendar.JulianDay);
     Edit6.Text:= Calendar.FormatJulianDayShort(Calendar.JulianDay);
     I:= Calendar.DayOfWeek(Calendar.Year,Calendar.Month,Calendar.Day);
     Edit7.Text:= IntToStr(I)+', '+LongDayNames[I+1];
     I:= Calendar.DayOfYear(Calendar.Year,Calendar.Month,Calendar.Day);
     Edit8.Text:= IntToStr(I)+' day of the year';
     I:= Calendar.DaysInMonth(Calendar.Year,Calendar.Month);
     Edit9.Text:= IntToStr(I)+' days this month';
     If Calendar.LeapYear(Calendar.Year)
        then Edit10.Text:= 'This is a leap year'
        else Edit10.Text:= 'This is not a leap year';
     Edit11.Text:= 'Historical year is '+Calendar.ADBC(Calendar.Year);
     If Calendar.LocalTime
        then Edit12.Text:= 'Bias from GMT is used'
        else Edit12.Text:= 'Bias from GMT is not used';
     Edit13.Text:= 'Time offset from GMT is '+
                   Format('%1.2f',[24*Calendar.LocalTimeBias])+' (hours)';
     If Calendar.Gregorian(Calendar.Year,Calendar.Month,Calendar.Day)
        then Edit14.Text:= 'After Gregorian reform (1582/10/4)'
        else Edit14.Text:= 'Before Gregorian reform (1582/10/4)';
     Memo1.Clear;
     AText:= 'ISO Date: [ '+
             IntToStr(Calendar.Year)+'-'+
             IntToStr(Calendar.Month)+'-'+
             IntToStr(Calendar.Day)+' ]';
     Memo1.Lines.Add(AText);
     Memo1.Lines.Add('');
     AText:= 'The corresponding Julian Day Number is ';
     AText:= AText+Format('%8.1f',[Calendar.JulianDay])+' (Noon)';
     Memo1.Lines.Add(AText);
     Memo1.Lines.Add('');
     Memo1.Lines.Add('The Moon phases, (Dynamical Time), are as follows:');
     Memo1.Lines.Add('');
     For I:= 0 to 4 do begin
         If Calendar.Phases[I].JD>0 then begin
            AText:= PhaseName(Calendar.Phases[I].Index)+':';
            Memo1.Lines.Add(AText);
            AText:= Calendar.FormatJulianDay(Calendar.Phases[I].JD);
            Memo1.Lines.Add(AText);
            Memo1.Lines.Add('');
         end;
     end;
end;

procedure TForm1.FormShow(Sender: TObject);
Var
   Y,M,D   : Word;
begin
     DecodeDate(Now,Y,M,D);
     Calendar.JulianDay:= Calendar.JD(Y,M,D,12,0,0);
end;

end.
